import { BaseQuery } from './BaseQuery';
export declare class MysqlQuery extends BaseQuery {
    newFilter(filter: any): any;
    castToString(sql: any): string;
    convertTz(field: any): string;
    timeStampCast(value: any): string;
    timestampFormat(): string;
    dateTimeCast(value: any): string;
    subtractInterval(date: any, interval: any): string;
    addInterval(date: any, interval: any): string;
    timeGroupedColumn(granularity: any, dimension: any): string;
    /**
     * Returns sql for source expression floored to timestamps aligned with
     * intervals relative to origin timestamp point.
     */
    dateBin(interval: string, source: string, origin: string): string;
    private isIntervalYM;
    /**
     * The input interval with (possible) plural units, like "2 years", "3 months", "4 weeks", "5 days"...
     * will be converted to MYSQL dialect.
     * @see https://dev.mysql.com/doc/refman/8.4/en/expressions.html#temporal-intervals
     */
    private formatInterval;
    escapeColumnName(name: any): string;
    seriesSql(timeDimension: any): string;
    concatStringsSql(strings: any): string;
    unixTimestampSql(): string;
    wrapSegmentForDimensionSelect(sql: any): string;
    preAggregationTableName(cube: any, preAggregationName: any, skipSchema: any): string;
    sqlTemplates(): any;
}
//# sourceMappingURL=MysqlQuery.d.ts.map